<?xml version="1.0" encoding="UTF-8"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">

	<xs:group name="GlobalPlugins">
		<xs:all>
			<xs:element name="Event" 			type="Event"		minOccurs="0"	maxOccurs="unbounded"/>
			<xs:element name="System" 				type="System"	minOccurs="0"	maxOccurs="unbounded"/>
		</xs:all>
	</xs:group>
	
	<xs:group name="CellTypePlugins">
		<xs:all>
			<xs:element name="Event" 			type="Event"		minOccurs="0"	maxOccurs="unbounded"/>
			<xs:element name="System" 				type="System"	minOccurs="0"	maxOccurs="unbounded"/>
		</xs:all>
	</xs:group>

	<xs:group name="PDEPlugins">
		<xs:all>
			<xs:element name="System" 				type="System"	minOccurs="0"	maxOccurs="unbounded"/>
		</xs:all>
	</xs:group>
	
	<xs:complexType name="System">
		<xs:complexContent>
			<xs:extension base="morphProcessPlugin">
				<xs:annotation>
					<!--PLUGIN CLASSES: Container / Shape / Motility / Math / Reporter / Misc-->
					<xs:appinfo>Math</xs:appinfo>
				</xs:annotation>

				<xs:all>
					<xs:group ref="SystemPlugins" />
				</xs:all>
<!-- 				<xs:attribute name="ad-solver" type="morphADSolver" use="optional" default="Explicit"/> -->
				<xs:attribute name="time-scaling" type="cpmDouble" use="optional" default="1.0" />
				<xs:attribute name="solver" type="morphSolver" use="required" default="Dormand-Prince [adaptive, O(5)]"/>
				<xs:attribute name="solver-eps" type="cpmDouble" use="optional" default="1e-4"/>
			</xs:extension>
		</xs:complexContent>
	</xs:complexType>

	<xs:simpleType name="morphSolver">
		<xs:restriction base="xs:string">
			<xs:enumeration value="Dormand-Prince [adaptive, O(5)]"/>
			<xs:enumeration value="Cash-Karp [adaptive, O(5)]"/>
			<xs:enumeration value="Bogacki-Shampine [adaptive, O(3)]"/>
			<xs:enumeration value="Runge-Kutta [fixed, O(4)]"/>
			<xs:enumeration value="Heun [fixed, O(2)]"/>
			<xs:enumeration value="Euler [fixed, O(1)]"/>
			<xs:enumeration value="Euler-Maruyama [stochastic, O(1)]"/>
<!-- 			<xs:enumeration value="Cash-Karp+Rosenbrock"/> -->
		</xs:restriction>
	</xs:simpleType>
	
	<xs:simpleType name="morphADSolver">
		<xs:restriction base="xs:string">
			<xs:enumeration value="Explicit"/>
			<xs:enumeration value="Implicit"/>
		</xs:restriction>
	</xs:simpleType>
	
	<xs:complexType name="DiscreteSystem">
		<xs:complexContent>
			<xs:extension base="morphProcessPlugin">
				<xs:annotation>
					<!--PLUGIN CLASSES: Container / Shape / Motility / Math / Reporter / Misc-->
					<xs:appinfo>Math</xs:appinfo>
					<xs:documentation>System of equations that is updated synchronously.</xs:documentation>
				</xs:annotation>
				
				<xs:all minOccurs="0" maxOccurs="unbounded">
					<xs:group ref="DiscreteSystemPlugins" />
				</xs:all>
			</xs:extension>
		</xs:complexContent>
	</xs:complexType>
	
	<xs:complexType name="TriggeredSystem">
		<xs:annotation>
			<!--PLUGIN CLASSES: Container / Shape / Motility / Math / Reporter / Misc-->
			<xs:appinfo>Math</xs:appinfo>
			<xs:documentation>System of equations that is updated synchronously when triggered.</xs:documentation>
		</xs:annotation>
		
		<xs:all>
			<xs:group ref="DiscreteSystemPlugins" />
		</xs:all>
		<xs:attribute name="name" type="cpmString" use="optional" />
	</xs:complexType>
	
	<xs:complexType name="morphEventCondition">
		<xs:simpleContent>
			<xs:extension base="cpmMathExpression">
				<xs:attribute name="history" use="optional" type="cpmBoolean" default="false" />
<!-- 				<xs:attribute name="persistent" use="optional" type="cpmBoolean" default="true" /> -->
			</xs:extension>
		</xs:simpleContent>
	</xs:complexType>
	
	<xs:simpleType name="morphEventLoggingFormat">
		<xs:restriction base="xs:string">
			<xs:enumeration value="csv"/>
			<xs:enumeration value="tsv"/>
			<xs:enumeration value="json"/>
		</xs:restriction>
	</xs:simpleType>
	
	<xs:complexType name="morphEventLogging">
		<xs:complexContent>
			<xs:attribute name="filename" type="cpmString" use="optional" />
			<xs:attribute name="format" type="morphEventLoggingFormat" use="optional" default="tsv"/>
			<xs:all>
				<xs:element name="Symbol" minOccurs="0" maxOccurs="unbounded" >
					<xs:complexType>
						<xs:attribute name="symbol-ref" type="cpmDoubleSymbolRef" use="required"/>
					</xs:complexType>
				</xs:element>
			</xs:all>
		</xs:complexContent>
	</xs:complexType>
	
	<xs:complexType name="Event">
		<xs:complexContent>
			<xs:extension base="morphProcessPlugin">
				<xs:annotation>
					<xs:appinfo>Math</xs:appinfo>
				</xs:annotation>
				<xs:all>
					<xs:element name="Condition" type="morphEventCondition" minOccurs="1" maxOccurs="1" />
					<xs:element name="Logging" type="morphEventLogging" minOccurs="0" maxOccurs="1" />
					<xs:group ref="DiscreteSystemPlugins" />
				</xs:all>
				<xs:attribute name="trigger" type="cpmEventTriggerMode" use="optional" default="on-change" />
				<xs:attribute name="compute-time" type="cpmEventDelayMode" use="optional" default="on-trigger" />
				<xs:attribute name="delay" type="cpmMathExpression" use="optional" default="0" />
				<xs:attribute name="persistent" type="cpmBoolean" use="optional" default="true" />
			</xs:extension>
		</xs:complexContent>

	</xs:complexType>

	<xs:simpleType name="cpmEventTriggerMode">
		<xs:restriction base="xs:string">
			<xs:enumeration value="on-change"/>
			<xs:enumeration value="when-true"/>
		</xs:restriction>
	</xs:simpleType>
	
	<xs:simpleType name="cpmEventDelayMode">
		<xs:restriction base="xs:string">
			<xs:enumeration value="on-trigger"/>
			<xs:enumeration value="on-execution"/>
		</xs:restriction>
	</xs:simpleType>
</xs:schema>

